<?php

namespace Drupal\Tests\project_wiki\Functional;

use Drupal\FunctionalJavascriptTests\WebDriverTestBase;

/**
 * This class provides methods specifically for testing something.
 *
 * @group project_wiki_markdown_content
 */
class ProjectWikiListjsTest extends WebDriverTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'project_wiki',
    'project_wiki_entity_content',
  ];

  /**
   * A user with authenticated permissions.
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $user;

  /**
   * A user with admin permissions.
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $adminUser;

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    parent::setUp();
    $this->config('system.site')->set('page.front', '/test-page')->save();
    $this->user = $this->drupalCreateUser([]);
    $this->adminUser = $this->drupalCreateUser([]);
    $this->adminUser->addRole($this->createAdminRole('admin', 'admin'));
    $this->adminUser->save();
    $this->drupalLogin($this->adminUser);
  }

  /**
   * Tests the functionality of the ListJS library.
   */
  public function testInstallUninstall() {
    $session = $this->assertSession();
    $page = $this->getSession()->getPage();
    // Create three test entries that will later be searched for and sorted.
    $this->drupalGet('/project-wiki-entity-content/add');
    $page->fillField('edit-category-0-value', 'Category A');
    $page->fillField('edit-title-0-value', 'Title A');
    $page->fillField('edit-content-0-value', 'The content is unimportant yet required here.');
    $page->pressButton('edit-submit');
    //$session->statusCodeEquals(200);
    $this->drupalGet('/project-wiki-entity-content/add');
    $page->fillField('edit-category-0-value', 'Category B');
    $page->fillField('edit-title-0-value', 'Title B');
    $page->fillField('edit-content-0-value', 'The content is unimportant yet required here.');
    $page->pressButton('edit-submit');
    //$session->statusCodeEquals(200);
    $this->drupalGet('/project-wiki-entity-content/add');
    $page->fillField('edit-category-0-value', 'Category C');
    $page->fillField('edit-title-0-value', 'Title C');
    $page->fillField('edit-content-0-value', 'The content is unimportant yet required here.');
    $page->checkField('edit-isdevelopercontent-value');
    $page->pressButton('edit-submit');
    //$session->statusCodeEquals(200);
    $this->drupalGet('/admin/help/project_wiki');
    //$session->statusCodeEquals(200);
  }

}
